
include Kasumi.asm
include gsm.inc

.data

	bigkey		BYTE		60 dup(?)
	mask1	BYTE	1h, 3h, 7h, 0Fh, 1Fh, 3Fh, 7Fh, 0FFh
	
.code

GSM proc this_:DWORD, key:PTR BYTE, klen:BYTE, count:DWORD
	
	LOCAL ck1[16]:BYTE, data1[32]:BYTE, i, bl1[15]:BYTE, bl2[15]:BYTE, bl3[15]:BYTE, bl4[15]:BYTE
	
	invoke	BuildKey, key, klen, addr ck1

	invoke	KGcore, 0Fh, 0h, count, 0h, addr ck1, addr data1, 228
	invoke	TwoBlocks, addr data1, addr bl1
	
	add		count, 1
	invoke	KGcore, 0Fh, 0h, count, 0h, addr ck1, addr data1, 228
	invoke	TwoBlocks, addr data1, addr bl2
	
	add		count, 1
	invoke	KGcore, 0Fh, 0h, count, 0h, addr ck1, addr data1, 228
	invoke	TwoBlocks, addr data1, addr bl3
	
	add		count, 1
	invoke	KGcore, 0Fh, 0h, count, 0h, addr ck1, addr data1, 228
	invoke	TwoBlocks, addr data1, addr bl4
	
	invoke	Stick, addr bl1, addr bl2, addr bl3, addr bl4
	
	xor		eax, eax
	ret

GSM endp

KGcore proc ca:BYTE, cb:BYTE, cc:DWORD, cd:BYTE, ck1:PTR BYTE, co1:PTR BYTE, cl1:DWORD
	
	LOCAL	key[16]:BYTE, ModKey[16]:BYTE, blkcnt:WORD, A[8]:BYTE, temp[8]:BYTE, n, i
	
	mov		edi, ck1
	
	mov		edx, 0
	mov		ecx, 16
	L1:
		mov		al, [edi][edx]
		mov		key[edx], al
		add		edx, 1
		loop L1
		
	mov		ecx, 8
	mov		edx, 0 
	L2:
		mov		A[edx], 0
		mov		temp[edx], 0
		inc		edx
		loop L2

	mov		al, byte ptr cc+3
	mov		A[0], al
	mov		al, byte ptr cc+2
	mov		A[1], al
	mov		al, byte ptr cc+1
	mov		A[2], al
	mov		al, byte ptr cc
	mov		A[3], al
	mov		al, cb
	shl		al, 3
	mov		A[4], al
	mov		al, cd
	shl		al, 2
	or		A[4], al
	mov		al, ca
	mov		A[5], al

	mov		edi, ck1
	xor		eax, eax
	mov		ecx, 16
	mov		edx, 0
	L3:
		mov		al, [edi][edx]
		xor		al, 55h
		mov		ModKey[edx], al
		inc		edx
		loop L3
		
	invoke	KeySchedule, addr ModKey

	xor		eax, eax				
	invoke	Kasumi, addr A			

	mov		blkcnt, 0
	lea		eax, key
	invoke	KeySchedule, eax
	
	mov		i, 0				; i - skvoznoj schetchik po massivu co1
	mov		esi, co1
	mov		ecx, 228
	L4:
		push	ebx
		push	ecx
		mov		ebx, dword ptr A
		xor		dword ptr temp, ebx
		mov		ebx, dword ptr A+4
		xor		dword ptr temp+4, ebx
		mov		bx, blkcnt
		xor		temp[7], bl
		
		invoke Kasumi, addr temp
		
		pop		ecx
		cmp		ecx, 64
		jb		lab1
		mov		n, 8
		jmp		lab_next
	lab1:
		mov		eax, ecx
		add		eax, 7
		shr		eax, 3
		mov		n, eax
	lab_next:
		push		ecx
		mov		eax, i
		mov		ecx, n
		mov		edx, 0
		L5:
			mov		bl, temp[edx]
			mov		[esi][eax], bl
			inc		eax
			inc		edx
			loop	L5
		mov		i, eax	
		
		pop		ecx
		cmp		ecx, 64
		jb		lab2
		sub		ecx, 63
		jmp		lab_end
	lab2:
		mov		ecx, 1
	lab_end:
		pop		ebx
		inc		blkcnt
		loop L4

	ret
KGcore endp

BuildKey proc k:PTR BYTE, len1:BYTE, ck1:PTR BYTE
	
	LOCAL	i, n, sf
	
	mov		esi, ck1
	xor		eax, eax
	mov		al, len1
	add		al, 7
	shr		eax, 3
	mov		i, eax

	cmp		i, 16
	jb		lab0
lab1:	
	mov		i, 16				; if (i>16) i=16

lab0:	
	mov		edi, k
	mov		edx, 0
	mov		ecx, i
	L1:
		mov		al, [edi][edx]
		mov		[esi][edx], al
		inc		edx
		loop L1
		
	xor		eax,eax
	mov		al, len1
	mov		bl, 8
	div		bl
	shr		eax, 8
	mov		sf, eax
	
	cmp		len1, 128
	jae		lab_end					; if (len >= 128)

	mov		n, 0
	cmp		sf, 0
	je		lab3					; if (sf==0)

	mov		al, mask1[sf]
	mov		ebx, i-1
	and		[esi][ebx], al
	mov		eax, 0
	mov		al, [esi][0]
	mov		ecx, sf
	shl		eax, cl
	add		[esi][ebx], al
	
	mov		edi, i
	mov		ecx, 16
	sub		ecx, edi
	L3:
		push	ecx

		mov		eax, 0
		mov		ebx, n
		mov		al, [esi][ebx]
		mov		ecx, 8
		sub		ecx, sf
		shr		eax, cl
		
		mov		ecx, sf
		mov		bl, [esi][ebx+1]
		shl		ebx, cl
		
		add		eax, ebx
		mov		[esi][edi], al
		
		inc		n
		inc		edi

		pop		ecx
		loop	L3
	jmp		lab_end

lab3:
	xor		eax, eax
	mov		ecx, 16
	sub		ecx,i
	mov		edi, i
	L2:
		mov		eax, n
		mov		al, [esi][eax]
		mov		[esi][edi], al
		inc		n
		inc		edi
		loop L2
lab_end:

	ret

BuildKey endp

Stick proc b1:PTR BYTE, b2:PTR BYTE, b3:PTR BYTE, b4:PTR BYTE		; Skleivaem iz chetyreh 15-bajtovyh blokov 1 60-bajtovyj. -> bigkey
	
	mov		edi, b1
	mov		esi, b2

		mov		ebx, 0					; skleivaem bl1 i bl2
		mov		ecx, 15
		L1:
			push	ecx
			mov		al, [edi][ebx]
			mov		bigkey[ebx], al
			mov		al, [esi][ebx]
			mov		bigkey[ebx+15], al
			inc		ebx
			pop		ecx
			loop L1	
		
		mov		ecx, 15					; uplotnyaem bl1 i bl2; ebx = 15
		L2:
			push	ecx
			xor		eax, eax
			mov		al, bigkey[ebx]
			and		al, 0FCh
			shr		eax, 2
			or		bigkey[ebx-1], al
			shl		bigkey[ebx], 6
			inc		ebx
			pop		ecx
			loop L2	

	mov		edi, b3
	mov		esi, b4
	
		mov		edx, 30
		mov		ebx, 0					; skleivaem bl3 i bl4
		mov		ecx, 15
		L3:
			push	ecx
			mov		al, [edi][ebx]
			mov		bigkey[edx], al
			mov		al, [esi][ebx]
			mov		bigkey[edx+15], al
			add		edx, 1
			inc		ebx
			pop		ecx
			loop L3	
		
		mov		ebx, edx
		mov		ecx, 15					; uplotnyaem bl3 i bl4; ebx = 45
		L4:
			push	ecx
			xor		eax, eax
			mov		al, bigkey[ebx]
			and		al, 0FCh
			shr		eax, 2
			or		bigkey[ebx-1], al
			shl		bigkey[ebx], 6
			inc		ebx
			pop		ecx
			loop L4	

	mov		ebx, 30						; udalyaem pustue bity v seredine bigkey
	mov		ecx, 30
	L5:
		push	ecx
		xor		eax, eax
		mov		al, bigkey[ebx]
		mov		bigkey[ebx-1], al
		and		al, 0F0h
		shr		eax, 4
		or		bigkey[ebx-2], al
		shl		bigkey[ebx-1], 4
		inc		ebx		
		pop		ecx
		loop L5

	ret
Stick endp

Enc_Dec proc this_:DWORD, buft:PTR BYTE			; Encryption / Decryption		-> buft
	mov		eax, this_
	mov		edi, buft
	mov		esi, 0
	mov		ecx, 57
	L_enc:
		push	ecx
;		mov		al, (MyComObject ptr [eax]).nValue[esi]
		mov		al, bigkey[esi]
		xor		[edi][esi], al
		inc		esi
		pop		ecx
		loop L_enc
	xor		eax, eax

	ret
Enc_Dec endp

TwoBlocks proc dat:PTR BYTE, bl1:PTR BYTE		; We don't use block2.....
	
	LOCAL bl2[15]:BYTE
	
	xor		eax, eax
	mov		edi, bl1
	mov		esi, dat
	mov		ecx, 15
	mov		edx, 0
	L1:
		mov		al, [esi][edx]
		mov		[edi][edx], al
		mov		al, [esi][edx+14]
		shl		eax, 2
		mov		bl2[edx], al
		xor		eax, eax
		mov		al, [esi][edx+15]
		shr		eax, 6
		add		bl2[edx], al
		inc		edx
		loop L1
	mov		al, 0C0h
	and		[edi][14], al
	and		bl2[14], al
	
	ret

TwoBlocks endp

